BuildRequires: /proc
BuildRequires: jpackage-1.4-compat
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define base_name   torque

Name:           db-torque
Version:        3.1.1
Release:        alt1_7jpp1.7
Epoch:          0
Summary:        Torque persistence layer

Group:          Development/Java
License:        Apache Software License
URL:            http://db.apache.org/torque/
Source0:        torque-3.1.1-src.tar.gz
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        db-torque-3.1.1-jpp-depmap.xml

Patch0:         torque-3.1-no-stratum.patch
Patch1:         db-torque-maven-plugin-3.1.1-plugin_jelly.patch
Patch2:         db-torque-3.1.1-project-base_xml.patch
Patch3:         db-torque-3.1.1-generator-project_xml.patch

%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: junit
%if %{with_maven}
BuildRequires: maven-plugins >= 0:1.1
%endif
BuildRequires: excalibur-avalon-framework-api
BuildRequires: excalibur-avalon-logkit
BuildRequires: gnu.getopt
BuildRequires: jakarta-commons-beanutils
BuildRequires: jakarta-commons-collections
BuildRequires: jakarta-commons-configuration >= 0:1.2
BuildRequires: jakarta-commons-dbcp
BuildRequires: jakarta-commons-lang
BuildRequires: jakarta-commons-logging
BuildRequires: jakarta-commons-pool
BuildRequires: jakarta-jcs
BuildRequires: log4j
BuildRequires: village
BuildRequires: xerces-j2
BuildRequires: xml-commons-apis
Requires: excalibur-avalon-framework-api
Requires: excalibur-avalon-logkit
Requires: jakarta-commons-beanutils
Requires: jakarta-commons-collections
Requires: jakarta-commons-configuration >= 0:1.2
Requires: jakarta-commons-dbcp
Requires: jakarta-commons-lang
Requires: jakarta-commons-logging
Requires: jakarta-commons-pool
Requires: jakarta-jcs
Requires: jdbc-stdext >= 0:2.0
Requires: jndi >= 0:1.2.1
Requires: log4j
Requires: village
Requires: xerces-j2
Requires: xml-commons-apis
%if %{gcj_support}
BuildRequires: gnu-crypto
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description
Torque is a persistence layer. Torque includes a 
generator to generate all the database resources 
required by your application and includes a 
runtime environment to run the generated classes. 

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
%{summary}.

%if %{with_maven}
%package        manual
Summary:        Docs for %{name}
Group:          Development/Documentation

%description    manual
%{summary}.
%endif

%package        gen
Summary:        Generator for %{name}
Group:          Development/Java

%description    gen
%{summary}.

%package        gen-javadoc
Summary:        Javadoc for %{name}-gen
Group:          Development/Documentation

%description    gen-javadoc
%{summary}.

%if %{with_maven}
%package        gen-manual
Summary:        Docs for %{name}-gen
Group:          Development/Documentation

%description    gen-manual
%{summary}.
%endif

%if %{with_maven}
%package        maven-plugin
Summary:        Maven plugin for %{name}
Group:          Development/Java
Requires: %{name}-gen = %{epoch}:%{version}

%description    maven-plugin
%{summary}.
%endif

%if %{with_maven}
%package        maven-plugin-manual
Summary:        Docs for %{name}-maven-plugin
Group:          Development/Documentation

%description    maven-plugin-manual
%{summary}.
%endif

%prep
%setup -q -n %{base_name}-%{version}-src

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav

%build
%if %{with_maven}
export DEPCAT=$(pwd)/db-torque-3.1.1-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > db-torque-3.1.1-depmap.new.xml

for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

mkdir .maven
mkdir -p .maven/repository/JPP/jars
touch .maven/repository/JPP/jars/jdbc-stdext.jar
touch .maven/repository/JPP/jars/jndi.jar
touch .maven/repository/JPP/jars/stratum.jar



MAVEN_HOME_LOCAL=$(pwd)/.maven
pushd src/generator
maven \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar javadoc xdoc:transform
popd
cp src/generator/target/torque-gen-3.1.1.jar .maven/repository/JPP/jars/db-torque-gen.jar
pushd src/maven-plugin
maven \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar javadoc xdoc:transform
popd
maven \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar javadoc xdoc:transform
%else
pushd src/generator
export CLASSPATH=$(build-classpath commons-lang velocity village):target/classes:target/test-classes
ant -Dbuild.sysclasspath=only jar javadoc
popd
CLASSPATH=
export CLASSPATH=$(build-classpath commons-lang commons-configuration commons-dbcp commons-pool jakarta-jcs excalibur/avalon-framework-api village):target/classes:target/test-classes
ant -Dbuild.sysclasspath=only jar javadoc
%endif

%install
install -dm 755 $RPM_BUILD_ROOT%{_javadir}
install -Dpm 644 target/%{base_name}-%{version}.jar \
                  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -Dpm 644 src/generator/target/%{base_name}-gen-%{version}.jar \
                  $RPM_BUILD_ROOT%{_javadir}/%{name}-gen-%{version}.jar

%if %{with_maven}
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/maven/repository/JPP/plugins
install -Dpm 644 src/maven-plugin/target/maven-torque-plugin-%{version}.jar \
 $RPM_BUILD_ROOT%{_datadir}/maven/repository/JPP/plugins/maven-torque-plugin-%{version}.jar
%endif

ln -s %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar
ln -s %{name}-gen-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-gen.jar
%if %{with_maven}
ln -s maven-torque-plugin-%{version}.jar \
  $RPM_BUILD_ROOT%{_datadir}/maven/repository/JPP/plugins/maven-torque-plugin.jar
%endif

install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf
cp -pr src/conf/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/profile
cp -pr profile/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf

# javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%if %{with_maven}
cp -pr target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
rm -rf target/docs/apidocs
%else
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%endif
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp *.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%if %{with_maven}
cp -pr target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%endif


# generator javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-gen-%{version}
%if %{with_maven}
cp -pr src/generator/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-gen-%{version}
rm -rf src/generator/target/docs/apidocs
%else
cp -pr src/generator/dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-gen-%{version}
%endif
ln -s %{name}-gen-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}-gen # ghost symlink

%if %{with_maven}
# generator manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-gen-%{version}
cp -pr src/generator/target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-gen-%{version}

# maven-plugin manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-maven-plugin-%{version}
cp -pr src/maven-plugin/target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-maven-plugin-%{version}
%endif

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%post gen-javadoc
rm -f %{_javadocdir}/%{name}-gen
ln -s %{name}-gen-%{version} %{_javadocdir}/%{name}-gen

%postun gen-javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}-gen
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post gen
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun gen
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%doc %{_docdir}/%{name}-%{version}/*.txt
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_datadir}/%{name}-%{version}
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%if %{with_maven}
%files manual
%doc %{_docdir}/%{name}-%{version}
%endif

%files gen
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/%{name}-gen-%{version}.jar
%{_javadir}/%{name}-gen.jar
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-gen-%{version}.jar.*
%endif

%files gen-javadoc
%doc %{_javadocdir}/%{name}-gen-%{version}
%ghost %doc %{_javadocdir}/%{name}-gen

%if %{with_maven}
%files gen-manual
%doc %{_docdir}/%{name}-gen-%{version}
%endif

%if %{with_maven}
%files maven-plugin
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_datadir}/maven/repository/JPP/plugins/maven-torque-plugin-%{version}.jar
%{_datadir}/maven/repository/JPP/plugins/maven-torque-plugin.jar
%endif

%if %{with_maven}
%files maven-plugin-manual
%doc %{_docdir}/%{name}-maven-plugin-%{version}
%endif

%changelog
* Fri Aug 10 2007 Igor Vlasenko <viy@altlinux.ru> 0:3.1.1-alt1_7jpp1.7
- converted from JPackage by jppimport script

